var exp = /[\-+*\/\.\(\)^,\s\uFF0B\uFF0D\u00D7\u00F7\uFF08\uFF09\u3014\u3015]|0x[0-9a-f]+|\d+|Math.(?:E|LN2|LN10|LOG2E|LOG10E|PI|SQRT1_2|SQRT2)|(?:Math.)?(?:abs|acos|asin|atan|atan2|ceil|cos|exp|floor|log|max|min|pow|random|round|sin|sqrt|tan)/gi;
var op = "+-*/()()";
var opf = "\uFF0B\uFF0D\u00D7\u00F7\uFF08\uFF09\u3014\u3015";
var m = new Array();
var s = WScript.StdIn.Read(8192); // limit the amount of characters to 8192 to avoid accidental execution on large documents
var out = WScript.StdOut;
var arr;
while ((arr = exp.exec(s)) != null) {
	m.push (arr.join("")); // extract expression
}
s = m.join("").replace (
	/(?:Math.)?(abs|acos|asin|atan|atan2|ceil|cos|exp|floor|log|max|min|pow|random|round|sin|sqrt|tan)/gi, 
	function($0,$1,$2) { return "Math." + $1.toLowerCase (); }
	) // Math functions
	.replace (
	/Math.(E|LN2|LN10|LOG2E|LOG10E|PI|SQRT1_2|SQRT2)/gi,
	function($0,$1) { return "Math." + $1.toUpperCase (); }
	) // Math constants
	.replace(
	/([\uFF0B\uFF0D\u00D7\u00F7\uFF08\uFF09\u3014\u3015])/g,
	function($0,$1) { return op.substr(opf.indexOf($0), 1); }
	) // convert full width operators to ASCII operators
	.replace (/(^|[^\.\d])0{2,}(?=\.)/g, "0") // merge leading 0 before .
	.replace (/(^|[^\.\d])0+([1-9])/g, "$1$2") // remove leading 0 in numbers
	.replace (/([0-9])\s+(?=[0-9])/gm, "$1+") // spaces between number -> plus
	.replace (/\s/g, ""); // remove spaces
var hex = s.indexOf ("0x") != -1;

out.WriteLine ("Eval expression:");
out.WriteLine (s);
out.WriteLine ();
out.WriteLine ("Result:");
try {
	var r = eval(s);
	s = r.toFixed (10).replace (/\.([0-9]*?)0+$/g, "\.$1").replace (/\.$/, "");
	out.WriteLine (s);
	// copy result to clipboard if AutoIt installed and argument "/c" specified
	if (WScript.Arguments.Named.Exists("c")) {
		try {
			var a = new ActiveXObject("AutoItX3.Control");
			a.ClipPut (s);
			out.WriteLine ("Result copied to clipboard.");
		}
		catch (e) {/*ignore exception*/}
	}
	if (hex) {
		out.WriteLine ("HEX:");
		s = r >= 0 ? "0x" + r.toString(16).toUpperCase() : "-0x" + (-r).toString(16).toUpperCase();
		out.WriteLine (s);
	}
}
catch (e) {
	out.Write ("Evaluation exception occured: ");
	out.WriteLine (e.message);
}

